<?php

// Q-registerations 2.5 build:20110627

class cPost
{

// --------

public $id = -1;
public $topic = -1;
public $section = -1;
public $type = 'P';
public $icon = '00';
public $title = '';
public $issuedate = '0';
public $text = '';
public $modifdate = '0';
public $modifuser = -1;
public $modifname = '';
public $userid = -1;
public $username = '';
public $userrole = 'U';
public $userloca = '';
public $useravat = '';
public $usersign = '';
public $num = 0; // sequential number (used as massage number in a list of replies)

// --------

function cPost($aPost=null,$intNum=null)
{
  if ( isset($aPost) )
  {
    if ( is_integer($aPost) )
    {
      if ( $aPost<0 ) die('No post '.$aPost);
      global $oDB;
      $oDB->Query('SELECT p.*,u.role,u.location,u.photo,u.signature FROM '.TABPOST.' p LEFT JOIN '.TABUSER.' u ON p.userid=u.id WHERE p.id='.$aPost);
      $row = $oDB->Getrow();
      $this->MakeFromArray($row);
    }
    elseif ( is_array($aPost) )
    {
      $this->MakeFromArray($aPost);
    }
    else
    {
      die('Invalid constructor parameter#1 for class cPost ['.var_dump($aPost).']');
    }
  }
  if ( isset($intNum) ) $this->num = intval($intNum);
  if ( $_SESSION[QT]['viewmode']=='C' ) $this->text = QTcompact($this->text,0);
}

// --------

function MakeFromArray($aPost)
{
  if ( !is_array($aPost) ) { echo 'cPost->MakeFromArray: aPost is not an array '; var_dump($aPost); return false; }
  
  foreach($aPost as $strKey=>$oValue) {
  switch($strKey) {
    case 'id':       $this->id     = intval($oValue); break;
    case 'section':  $this->section= intval($oValue); break;
    case 'topic':    $this->topic  = intval($oValue); break;
    case 'type':     $this->type   = $oValue; break;
    case 'icon':     $this->icon   = $oValue; break;
    case 'title':    $this->title  = $oValue; break;
    case 'textmsg':  $this->text = $oValue; break;
    case 'issuedate':$this->issuedate= $oValue; break;
    case 'userid':   $this->userid   = intval($oValue); break;
    case 'username': $this->username = $oValue; break;
    case 'role':     $this->userrole = $oValue; break;
    case 'location': $this->userloca = $oValue; break;
    case 'photo':    $this->useravat = $oValue; break;
    case 'signature':$this->usersign = $oValue; break;
    case 'modifdate':$this->modifdate= $oValue; break;
    case 'modifuser':$this->modifuser= intval($oValue); break;
    case 'modifname':$this->modifname= $oValue; break;
  }}
}

// --------

function CanEdit()
{
  // By default, Staff can edit post of other staff (even Admin post)
  global $oVIP;
  if ( !$oVIP->auth ) return false;
  if ( $this->userid==$oVIP->id || $oVIP->role=='A' ) return true;
  if ( $oVIP->role=='M' )
  {
    if ( $this->userrole=='A' && !QTR_STAFFEDITADMIN ) return false;
    if ( $this->userrole=='M' && !QTR_STAFFEDITSTAFF ) return false;
    return true;
  }
  return false;
}

// --------

function InsertPost($bTopicStat=false,$bUserStat=false)
{
  global $oDB;
  $b = $oDB->Query('INSERT INTO '.TABPOST.' (id,section,topic,title,type,icon,userid,username,issuedate,textmsg) VALUES ('.$this->id.','.$this->section.','.$this->topic.',"'.addslashes(QTconv($this->title,'3',QTR_CONVERT_AMP,false)).'","'.$this->type.'","'.$this->icon.'",'.$this->userid.',"'.addslashes($this->username).'","'.$this->issuedate.'","'.addslashes(QTconv($this->text,'3',QTR_CONVERT_AMP,false)).'")');

  // Post processing

  if ( $b===true )
  {
    // Update Topic's replies and lastpost (inserting a post does NOT change de modifdate of the topic!)

    if ( $bTopicStat )
    {
    $oDB->Query('UPDATE '.TABTOPIC.' SET replies=replies+1,lastpostid='.$this->id.',lastpostuser='.$this->userid.',lastpostname="'.$this->username.'",lastpostdate="'.$this->issuedate.'" WHERE id='.$this->topic);
    }

    // Update system stats

    if ( isset($_SESSION[QT]['sys_topics']) && $this->type=='P' ) $_SESSION[QT]['sys_topics']++;
    if ( isset($_SESSION[QT]['sys_replies']) && $this->type!='P' ) $_SESSION[QT]['sys_replies']++;

    // Lastpost delay control

    $_SESSION['qtr_usr_lastpost'] = time();

    // Number of posts today control

    if ( isset($_SESSION['qtr_usr_posts_today']) )
    {
      if ( $this->type=='P' || $this->type=='R' ) $_SESSION['qtr_usr_posts_today']++;
    }

    // User stat

    if ( $bUserStat )
    {
    $oDB->Query('UPDATE '.TABUSER.' SET lastdate="'.$this->issuedate.'", numpost=numpost+1, ip="'.$oDB->ip.'" WHERE id='.$this->userid);
    $_SESSION[QT.'_usr_posts']++;
    }
  }
  else
  {
    // Error
    global $oVIP;
    $oVIP->EndMessage(NULL,'Unable to insert post.','admin',0);   
  }
}

// --------

function GetIcon($strSkin='skin/default',$strHref='')
{
  return AsImg($strSkin.'/ico_post_'.strtolower($this->type).'.gif','P',L('Ico_post_'.strtolower($this->type)),'ico ico_p','',$strHref);
}


// --------

function GetScore($oTopic)
{
  if ( $oTopic->type=='I' )
  {
    $i = strtolower(trim($this->title));
    if ( $i==='' || is_null($i) || $i==='null' ) $i=-1;
    if ( strlen($i)>4 ) $i = substr($i,0,4);
    if ( is_numeric($i) ) { $i=floatval($i); } else { $i=-1; }
    return $i;
  }
  return -1;
}
function GetScoreImage($oTopic,$bName=true)
{
  $i = $this->GetScore($oTopic);
  return ($i<0 ? S : ValueScalebar($i,$oTopic->ParamGet('Ilevel')).($bName ? ' '.ValueName($i,$oTopic->ParamGet('Ilevel')) : ''));
}
function GetScoreName($oTopic)
{
  $i = $this->GetScore($oTopic);
  return ($i<0 ? '' : ValueName($i,$oTopic->ParamGet('Ilevel')));
}

// --------

function Show($oSEC,$oTopic,$bAvatar=true,$strEndLine='',$strSep='',$strSkin='skin/default',$strAlt='r1')
{
  if ( !isset($oSEC) ) die('oPost->Show: Missing $oSEC');
  if ( !isset($oTopic) ) die('oPost->Show: Missing $oTopic');

  // Process

  global $oVIP,$L;
  
  // Prepare icon

  $strIcon = ($this->type=='P' ? $oTopic->GetIcon($strSkin) : $this->GetIcon($strSkin));

  // Prepare title

  if ( $this->type=='D' )
  {
    $strTitle = '<span title="'.$this->text.'">'.$L['Message_deleted'].'</span>';
  }
  else
  {
    $strTitle = $this->title;
    if ( $oTopic->type=='I' && $this->type=='R' ) $strTitle = $this->GetScoreImage($oTopic);
    if ( !empty($oSEC->wisheddate) && !empty($oTopic->wisheddate) )
    {
    $strTitle .= '<span class="small"> &middot; '.$L['Wisheddate'].': '.QTdatestr($oTopic->wisheddate,'$','',true).'</span>';
    }
  }

  // message container

  echo '
  <a id="p',$this->id,'"></a>
  <div class="post">
  <table class="hidden" cellspacing="0">
  <colgroup span="2"><col style="width:25px"></col><col></col></colgroup>
  ';

  echo '
  <tr class="hidden">
  <td class="msgheader msgicon ',$strAlt,'">',$strIcon,'</td>
  <td class="msgheader msgtitle ',$strAlt,'">
  <table class="hidden" cellpadding="0">
  <tr class="hidden">
  <td class="hidden"><p class="msgtitle">',$strTitle,'</p></td>
  <td class="hidden"><p class="msgattr">',($_SESSION[QT]['viewmode']=='C' || $oTopic->type=='I' ? '<a href="qtr_user.php?id='.$this->userid.'" class="msgtitle">'.$this->username.'</a>' : ''),S,QTdatestr($this->issuedate,'$','$',true),( $this->num>=0 ? '&nbsp;['.$this->num.']' : ''),'</p>';
  // ----------
  // module note
  if ( isset($_SESSION[QT]['m_note']) ) { if ( $_SESSION[QT]['m_note']=='1' ) MakeWarningButton($this); }
  // ----------
  echo '</td>
  </tr>
  </table>
  </td>
  </tr>
  ';

  if ( $this->type!='D' )
  {
    echo '<tr class="hidden">',N;
    echo '<td class="msgcontent msgsmile ',$strAlt,'">',($this->icon!='00' ? AsImg($strSkin.'/ico_prefix_'.$oSEC->prefix.'_'.$this->icon.'.gif','[o]',$L['Ico_prefix'][$oSEC->prefix.'_'.$this->icon],'ico i_pre') : S),'</td>',N;
    echo '<td class="msgcontent msgbody ',$strAlt,'">',N;

    // Avatar
    $strAvatar = ''; if ( is_string($bAvatar) ) $strAvatar = $bAvatar; // avatar can be replaced by something else (if string is provided)
    if ( $_SESSION[QT]['viewmode']!='C' && $bAvatar===true )
    {
      if ( !empty($this->useravat) ) $strAvatar = QTR_DIR_PIC.$this->useravat;
      $strAvatar = AsImgBox(
        AsImg($strAvatar,'',$this->username,'','','qtr_user.php?id='.$this->userid),
        'picboxmsg',
        '',
        QTconv($this->username,'5').($this->userrole!='U' ? '<br/>'.QTconv($L['Userrole'][$this->userrole],'5') : '').(empty($this->userloca) ? '' : '<br/>'.QTconv($this->userloca,'5')),
        'qtr_user.php?id='.$this->userid);
    }
    echo $strAvatar;

    // incident date
    if ( $this->type=='P' ) {    
    if ( !empty($oSEC->eventdate) && !empty($oTopic->eventdate) ) {
      echo '<p class="msgeventdate">',AsImg($strSkin.'/ico_topic_date.gif',$L['Eventdate'],$L['Eventdate'],'ico i_topic'),' '.QTdatestr($oTopic->eventdate,'$',($oSEC->eventdate=='3' || $oSEC->eventdate=='4' ? '$' : '')),'</p>',N;
    }}

    // message and signature
    echo '<p class="msgbody">';
      // format the text
      $str = QTbbc($this->text,'<br/>','</p>','<p class="msgbody">');
    echo $str,"</p>\n";

    if ( $_SESSION[QT]['viewmode']!='C' ){
    if ( $this->type!='F' ) {
    if ( !empty($this->usersign) ) {
      echo '<p class="msgsign">',QTbbc($this->usersign),'</p>',N;
    }}}

    // command line
    echo $strEndLine;
    echo '</td>',N,'</tr>',N;
  }

  echo '
  </table>
  </div>
  ';
}

// --------

function SetFromPost($bNew=true)
{
  $error='';
  global $oVIP,$strBehalf;

  // Identify the user (can be onbehalf)
    
  $this->modifuser = $oVIP->id;
  $this->modifname = $oVIP->username;
  if ( isset($_POST['behalf']) )
  {
    $strBehalf = trim($_POST['behalf']); if ( get_magic_quotes_gpc() ) $strBehalf = stripslashes($strBehalf);
    if ( !is_null($strBehalf) && $strBehalf!=='' )
    {
      // Find behalf id
      $strBehalf = htmlspecialchars($strBehalf,ENT_QUOTES);
      $intBehalf = current(array_keys(GetUsers('name',$strBehalf) )); // can be FALSE when not found
      if ( is_int($intBehalf) ) { $this->modifuser = $intBehalf; $this->modifname = $strBehalf; } else { $error=L('Send_on_behalf').' '.Error(1); }
    }
  }

  // Identify creator as being the user. When editing existing message ($bNew=false) then autor remains unchanged

  if ( $bNew )
  {
  $this->userid = $this->modifuser;
  $this->username = $this->modifname;
  }

  // Read message values
  
  if ( isset($_POST['icon']) ) $this->icon = $_POST['icon'];
  if ( isset($_POST['title']) ) $this->title = QTunbbc(trim((get_magic_quotes_gpc() ? stripslashes($_POST['title']) : $_POST['title'])));
  if ( isset($_POST['text']) ) $this->text = trim((get_magic_quotes_gpc() ? stripslashes($_POST['text']) : $_POST['text']));
 
  return $error;
}

// --------

}