<?php

// Q-registerations 2.5 build:20110627

session_start();

if ( !isset($_SESSION['qtr_setup_lang']) ) $_SESSION['qtr_setup_lang']='en';

include('qtr_lang_'.$_SESSION['qtr_setup_lang'].'.php');
include('../bin/config.php'); if ( $qtr_dbsystem=='sqlite' ) $qtr_database = '../'.$qtr_database;

$strAppl = 'Q-registerations';
$strPrevUrl = 'qtr_setup_1.php';
$strNextUrl = 'qtr_setup_3.php';
$strPrevLabel= $L['Back'];
$strNextLabel= $L['Next'];

// --------
// HTML START
// --------

include('qtr_setup_hd.php');

if ( isset($_POST['ok']) )
{
  include('../bin/qt_lib_db.php');
  include('../bin/qtr_fn_base.php');

  if ( isset($_SESSION['qtr_dbopwd']) )
  {
  $qtr_user = $_SESSION['qtr_dbologin'];
  $qtr_pwd = $_SESSION['qtr_dbopwd'];
  }
  $_SESSION['qtr_boardmail'] = strip_tags(trim($_POST['boardmail']));

  define('TABDOMAIN', $qtr_prefix.'qtrdomain');
  define('TABSECTION', $qtr_prefix.'qtrsection');
  define('TABUSER', $qtr_prefix.'qtruser');
  define('TABTOPIC', $qtr_prefix.'qtrtopic');
  define('TABPOST', $qtr_prefix.'qtrpost');
  define('TABSTATUS', $qtr_prefix.'qtrstatus');
  define('TABSETTING', $qtr_prefix.'qtrsetting');
  define('TABLANG', $qtr_prefix.'qtrlang');
  define('TABDATA', $qtr_prefix.'qtrdata');
  define('TABFIELD', $qtr_prefix.'qtrfield');
  define('TABTAB', $qtr_prefix.'qtrtab');
  define('TABDOC', $qtr_prefix.'qtrdoc');

  $oDB = new cDB($qtr_dbsystem,$qtr_host,$qtr_database,$qtr_user,$qtr_pwd,$qtr_port,$qtr_dsn);

  if ( empty($oDB->error) )
  {
    // Install the tables
    $strTable = TABSETTING;
    echo $L['Installation'].' SETTING... ';
    include('qtr_setup_setting.php');
    echo "{$L['Done']}, {$L['Default_setting']}<br/>";
    $strTable = TABDOMAIN;
    echo $L['Installation'].' DOMAIN... ';
    include('qtr_setup_domain.php');
    echo "{$L['Done']}, {$L['Default_domain']}<br/>";
    $strTable = TABSECTION;
    echo $L['Installation'].' SECTION... ';
    include('qtr_setup_section.php');
    echo "{$L['Done']}, {$L['Default_section']}<br/>";
    $strTable = TABTOPIC;
    echo $L['Installation'].' TOPIC... ';
    include('qtr_setup_topic.php');
    echo $L['Done'].'<br/>';
    $strTable = TABPOST;
    echo $L['Installation'].' POST... ';
    include('qtr_setup_post.php');
    echo $L['Done'].'<br/>';
    $strTable = TABUSER;
    echo $L['Installation'].' USER... ';
    include('qtr_setup_user.php');
    echo "{$L['Done']}, {$L['Default_user']}<br/>";
    $strTable = TABSTATUS;
    echo $L['Installation'].' STATUS... ';
    include('qtr_setup_status.php');
    echo $L['Done'].'<br/>';
    $strTable = TABLANG;
    echo $L['Installation'].' LANG... ';
    include('qtr_setup_lang.php');
    echo $L['Done'].'<br/>';
    $strTable = TABDATA;
    echo $L['Installation'].' DATA... ';
    include('qtr_setup_data.php');
    echo $L['Done'].'<br/>';
    $strTable = TABFIELD;
    echo $L['Installation'].' FIELD... ';
    include('qtr_setup_field.php');
    echo $L['Done'].'<br/>';
    $strTable = TABTAB;
    echo $L['Installation'].' TAB... ';
    include('qtr_setup_tab.php');
    echo $L['Done'].'<br/>';
    $strTable = TABDOC;
    echo $L['Installation'].' DOCUMENT... ';
    include('qtr_setup_doc.php');
    echo $L['Done'].'<br/>';
    if ( $result==FALSE )
    {
      echo '<div class="setup_err">',sprintf ($L['E_install'],$strTable,$qtr_database,$qtr_user),'</div>';
    }
    else
    {
      echo '<div class="setup_ok">',$L['S_install'],'</div>';
      $_SESSION['qtrInstalled'] = true;
      // save the url
      $strURL = ( empty($_SERVER['SERVER_HTTPS']) ? "http://" : "https://" ).$_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
      $strURL = substr($strURL,0,-24);
      $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$strURL.'" WHERE param="site_url"');
      // save the board email
      if ( isset($_SESSION['qtr_boardmail']) ) $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION['qtr_boardmail'].'" WHERE param="admin_email"');
    }
  }
  else
  {
    echo '<div class="setup_err">',sprintf ($L['E_connect'],$qtr_database,$qtr_host),'</div>';
  }

}
else
{
  echo '
  <table cellspacing="0">
  <tr valign="top">
  <td width="475" style="padding:5px">
  <form method="post" name="install" action="qtr_setup_2.php">',$L['Board_email'],' <input name="boardmail" value="',(isset($_SESSION['qtr_boardmail']) ? $_SESSION['qtr_boardmail'] : ''),'" size="34" maxlength="100"/>
  <h2>',$L['Install_db'],'</h2>
  <p class="small">',$L['Upgrade2'],'</p>
  <input type="submit" name="ok" value="',sprintf($L['Create_tables'],$qtr_database),'"/>
  </form>
  </td>
  <td class="hidden"><div class="setup_help">',$L['Help_2'],'</div></td>
  </tr>
  </table>
  ';
}

// --------
// HTML END
// --------

include('qtr_setup_ft.php');

?>