<?php

// Q-registerations 2.5 build:20110627

switch($oDB->type)
{

case 'mysql4':
case 'mysql':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrdoc (
  id int NOT NULL default 0,
  docdate varchar(20),
  docname varchar(255),
  docfile varchar(255),
  docpath varchar(255)
  )';
  break;

case 'sqlsrv':
case 'mssql':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrdoc (
  id int NOT NULL default 0,
  docdate varchar(20),
  docname varchar(255),
  docfile varchar(255),
  docpath varchar(255)
  )';
  break;

case 'pg':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrdoc (
  id integer NOT NULL default 0,
  docdate varchar(20),
  docname varchar(255),
  docfile varchar(255),
  docpath varchar(255)
  )';
  break;

case 'ibase':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrdoc (
  id integer default 0,
  docdate varchar(20),
  docname varchar(255),
  docfile varchar(255),
  docpath varchar(255)
  )';
  break;

case 'sqlite':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrdoc (
  id integer,
  docdate text,
  docname text,
  docfile text,
  docpath text
  )';
  break;

case 'db2':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrchild (
  id integer NOT NULL default 0,
  docdate varchar(20),
  docname varchar(255),
  docfile varchar(255),
  docpath varchar(255)
  )';
  break;

case 'oci':
  $strQ='CREATE TABLE '.$qtr_prefix.'qtrdoc (
  id number(32),
  docdate varchar2(20),
  docname varchar2(255),
  docfile varchar2(255),
  docpath varchar2(255)
  )';
  break;

default:
  die('Database type ['.$this->type.'] not supported... Must be mysql, sqlsrv, mssql, pg, ibase, db2, oci');
}

echo '<span style="color:blue;">';
$b=$oDB->Query($strQ);
echo '</span>';

if ( !empty($oDB->error) || !$b )
{
  echo '<div class="setup_err">',sprintf ($L['E_install'],$qtr_prefix.'qtrdoc',$qtr_database,$qtr_user),'</div>';
  echo '<br/><table cellspacing="0" class="button"><tr><td></td><td class="button" style="width:120px">&nbsp;<a href="qtr_setup_1.php">',$L['Restart'],'</a>&nbsp;</td></tr></table>';
  exit;
}