<?php

// Q-registerations 2.5 build:20110627

ob_start();

// check Welcome condition

$bWelcome = true;
if ( in_array($oVIP->selfurl,array('qtr_register.php','qtr_form_reg.php','qtr_change.php')) ) $bWelcome = false;
if ( $_SESSION[QT]['sys_welcome']=='0' ) $bWelcome = false;
if ( $_SESSION[QT]['sys_welcome']=='1' && $oVIP->auth ) $bWelcome = false;
if ( $_SESSION[QT]['board_offline']=='1' ) $bWelcome = false;
if ( !file_exists(Translate('sys_welcome.txt')) ) $bWelcome = false;

// check LangMenu condition

$strLangMenu = '';
if ( $_SESSION[QT]['userlang']=='1' )
{
  if ( file_exists('bin/qtr_lang.php') )
  {
    include('bin/qtr_lang.php');
    $strLangMenu = '';
    foreach ($arrLang as $strKey => $arrDef)
    {
    $strLangMenu .= '<a href="'.Href().'?'.GetURI('lx').'&amp;lx='.$strKey.'" title="'.$arrDef[1].'" class="'.($_SESSION[QT]['show_banner']=='1' ? 'banner' : 'nobanner').'">'.$arrDef[0].'</a> &middot; ';
    }
  }
  else
  {
    $strLangMenu .= '<span class="small">missing file:bin/qtr_lang.php</span>';
  }
}

// Contrast

if ( QTR_SHOW_CONTRAST )
{
  if ( !isset($strHeadScript) ) $strHeadScript='';
  $oHtml->links[] = '<link rel="stylesheet" type="text/css" href="bin/css/qtr_contrast.css" title="cssalternate" />';
  $strHeadScript .= '<script type="text/javascript" src="bin/css/qtr_contrast.js"></script>';
  $strLangMenu .= '<a class="css-default" href="javascript:chooseStyle(\'cssalternate\',60);"><img style="width:12px;height:12px;vertical-align:middle" src="bin/css/qtr_contrast.gif" title="High contrast display" alt="Contrast" /></a><a class="css-alternate" href="javascript:chooseStyle(\'cssmain\',60);"><img style="width:12px;height:12px;border-width:0;vertical-align:middle" src="bin/css/qtr_contrast.gif" title="Default display" alt="Contrast" /></a>';
}

// --------
// HTML START
// --------

$oHtml->title = (empty($oVIP->selfname) ? '' : $oVIP->selfname.' - ').$oHtml->title;
if ( !empty($strHeadScript) ) $oHtml->scripts[] = $strHeadScript;

echo $oHtml->Head();
echo $oHtml->Body(array('onload'=>(isset($strBodyAddOnload) ? $strBodyAddOnload : null),'onunload'=>(isset($strBodyAddOnunload) ? $strBodyAddOnunload : null)));

// PAGE

HtmlPageCtrl(0);

// BANNER

if ( $_SESSION[QT]['show_banner']=='1' )
{
  HtmlBanner(0,'','qtr_logo.gif',$strLangMenu);
}
else
{
  if ( !empty($strLangMenu) )
  {
  HtmlBanner(1,'','',$strLangMenu);
  }
}
// MENU LINE

$arrMenus = array(); // keys are: 'h' in header, 'f' in footer, 'n' name, 'u' url, 's' selected with url's, 'i' inactive with url's

if ( $_SESSION[QT]['home_menu']=='1' && !empty($_SESSION[QT]['home_url']) )
{
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$_SESSION[QT]['home_name'], 'u'=>$_SESSION[QT]['home_url']);
}
$arrMenus[]=array('h'=>false,'f'=>true, 'n'=>$L['Legal'], 'u'=>'qtr_privacy.php');
$arrMenus[]=array('h'=>false,'f'=>true, 'n'=>$L['FAQ'], 'u'=>'qtr_faq.php');
$arrMenus[]=array('h'=>true, 'f'=>false,'n'=>ObjTrans('index','i',$_SESSION[QT]['index_name']), 'u'=>'qtr_index.php', 's'=>'qtr_index.php qtr_calendar.php qtr_topics.php qtr_topic.php');
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Search'], 'u'=>($_SESSION[QT]['board_offline']=='1' || ($oVIP->role=='V' && $_SESSION[QT]['visitor_right']<3) ? '' : 'qtr_search.php'), 's'=>'qtr_search.php qtr_find.php', 'i'=>'');
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Memberlist'], 'u'=>($_SESSION[QT]['board_offline']=='1' || $_SESSION[QT]['visitor_right']<2 ? '' : 'qtr_member.php'));
if ( $oVIP->CanViewStats() ) 
{
$arrMenus[]=array('h'=>false,'f'=>true, 'n'=>$L['Statistics'], 'u'=>($_SESSION[QT]['board_offline']=='1' ? '' : 'qtr_stats.php'));
}
if ( $oVIP->auth )
{
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Profile'], 'u'=>($_SESSION[QT]['board_offline']=='1' ? '' : 'qtr_user.php?id='.$oVIP->id), 's'=>'qtr_user.php qtr_user_img.php.php qtr_user_sign.php qtr_user_pwd.php');
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Logout'], 'u'=>'qtr_login.php?a=out');
}
else
{
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Register'], 'u'=>($_SESSION[QT]['board_offline']=='1' ? '' : 'qtr_register.php'), 's'=>'qtr_register.php qtr_form_reg.php', 'i'=>'qtr_register.php');
$arrMenus[]=array('h'=>true, 'f'=>true, 'n'=>$L['Login'], 'u'=>'qtr_login.php');
}

echo '
<!-- menu -->
<div class="menu">
<div class="menuleft">',($oVIP->role=='V' ? AsImg($_SESSION[QT]['skin_dir'].'/ico_user_p_0.gif','-',$L['Ico_user_pZ'],'ico i_user') : AsImg($_SESSION[QT]['skin_dir'].'/ico_user_p_1.gif','-',$L['Ico_user_p'],'ico i_user')),'&nbsp;',($oVIP->role=='V' ? $L['Userrole']['V'] : $oVIP->username),'</div>
<div class="menuright">
<ul>
';
foreach($arrMenus as $arrMenu) {
if ( $arrMenu['h'] ) {
  if ( !isset($arrMenu['s']) ) $arrMenu['s']=' '.$arrMenu['u'];
  if ( !isset($arrMenu['i']) ) $arrMenu['i']=' '.$arrMenu['u'];
  if ( empty($arrMenu['u']) )
  {
  echo '<li><span>',$arrMenu['n'],'</span></li>',PHP_EOL;
  }
  else
  {
  echo '<li'.(strstr($arrMenu['s'],$oVIP->selfurl) ? ' id="menuactif"' : '').'><a href="',Href($arrMenu['u']),'" '.(strstr($arrMenu['i'],$oVIP->selfurl) ? ' onclick="return false;"' : '').'>',$arrMenu['n'],'</a></li>',PHP_EOL;
  }
}}
echo '</ul>
</div>
</div>
';

// WELCOME

$b = true;
if ( in_array($oVIP->selfurl,array('qtr_register.php','qtr_form_reg.php','qtr_change.php')) ) $b = false;
if ( $_SESSION[QT]['sys_welcome']=='0' ) $b = false;
if ( $_SESSION[QT]['sys_welcome']=='1' && $oVIP->auth) $b = false;
if ( $_SESSION[QT]['board_offline']=='1' ) $b = false;
if ( !file_exists(GetLang().'sys_welcome.txt') ) $b = false;
if ( $b )
{
echo '
<!-- welcome -->
<div class="welcome">';
include(Translate('sys_welcome.txt'));
echo '</div>
';
}

// MAIN

$ps = -1; // previous section
if ( isset($_SESSION[QT]['section']) ) {
if ( is_int($_SESSION[QT]['section']) ) {
if ( $_SESSION[QT]['section']>=0 ) {
  $ps = intval($_SESSION[QT]['section']);
}}}

echo '
<!-- MAIN CONTROL -->
<div class="body">
<div class="body_in">
';

echo '
<!-- top bar -->
<div class="bodyhd">
<div class="bodyhdleft"><img class="bodyhdleft" src="',$_SESSION[QT]['skin_dir'],'/ico_hd_left.gif" alt="" /><a class="body_hd" href="',Href('qtr_index.php'),'"',($oVIP->selfurl=='qtr_index.php' ? ' onclick="return false;"' : ''),'>',ObjTrans('index','i',$_SESSION[QT]['index_name']),'</a>';
if ( $ps>=0 )
{
  if ( isset($oVIP->sections[$ps]) )
  {
    echo QTR_CRUMBTRAIL,'<a class="body_hd" href="',Href('qtr_topics.php'),'?s=',$ps,'"',($oVIP->selfurl=='qtr_topics.php' ? ' onclick="return false;"' : ''),'>',ObjTrans('sec',"s$ps",(isset($oSEC) ? $oSEC->name : $oVIP->sections[$ps])),'</a>';
  }
  else
  {
    $ps=-1; unset($_SESSION[QT]['section']);
  }
  if ( isset($oTopic) && isset($oSEC) )
  {
    if ( $oTopic->numid>=0 && $oSEC->numfield!='N' ) echo QTR_CRUMBTRAIL,sprintf($oSEC->numfield,$oTopic->numid);
  }
  if ( $oVIP->selfurl=='qtr_calendar.php' && isset($intYear) )
  {
  if ( !empty($intYear) ) echo QTR_CRUMBTRAIL,$intYear;
  }
}
echo '</div>
<div class="bodyhdright">';

switch($oVIP->selfurl)
{
case 'qtr_topics.php':
  if ( $oVIP->CanViewCalendar() )
  {
  echo '<a href="',Href('qtr_calendar.php'),'?s=',$ps,'"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_f_c.gif" title="',$L['Ico_view_f_c'],'" alt="C" /></a> ';
  }
  break;
case 'qtr_result.php':
case 'qtr_topic.php':
case 'qtr_member.php':
  if ( $_SESSION[QT]['viewmode']=='C' )
  {
  echo '<a href="',Href(),'?',GetURI('view'),'&amp;view=N"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_n.gif" title="',$L['Ico_view_n'],'" alt="N" /></a>';
  }
  else
  {
  echo '<a href="',Href(),'?',GetURI('view'),'&amp;view=C"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_c.gif" title="',$L['Ico_view_c'],'" alt="C" /></a>';
  }
  break;
case 'qtr_calendar.php':
  if ( $ps>=0 ) echo '<a href="',Href('qtr_topics.php'),'?s=',$ps,'"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_f_n.gif" title="',$L['Ico_view_f_n'],'" alt="N" /></a>';
  break;
case 'qtr_stats.php':
  break;
}

// PDF

if ( $oVIP->role!='V' )
{
  $strURI = GetURI();
  if ( file_exists(substr($oVIP->selfurl,0,-4).'_pdf.php') )
  {
  echo '&nbsp;<a href="',substr($oVIP->selfurl,0,-4),'_pdf.php',(isset($strURI) ? '?'.$strURI : ''),'"><img class="ico i_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_pdf.gif" title="pdf" alt="pdf"/></a>';
  }
}

echo '&nbsp;<img class="bodyhdright" src="',$_SESSION[QT]['skin_dir'],'/ico_hd_right.gif" alt="" /></div>
</div>
';

// MAIN CONTENT

echo '
<!-- main content -->
<div class="bodyct">
';