<?php

// Q-registrations 2.5 build:20110627

// ---------
// INITIALIZE get field definition of this tab
// ---------

CheckDico('field fielddesc');

$arrFields = array();
foreach($arrOtherTabs as $strOtherTab=>$arrOtherTab)
{
  if ( $oVIP->role=='U' || $oVIP->role=='V' ) { $strWhere = ' AND fieldselect="1"'; } else { $strWhere=''; }
  $oDB->Query('SELECT * FROM '.TABFIELD.' WHERE tabid="'.$strOtherTab.'"'.$strWhere.' ORDER by fieldorder');
  while($row=$oDB->Getrow())
  {
    $strField = $row['fieldid'];
    $arrFields[$strField] = $row;
    // add the default value (of this langue) if required (date unformated)
    $arrFields[$strField]['default'] = '';
    if ( $row['fielddefault']=='1' )
    {
      if ( strstr('SLP',$row['fieldtype']) )
      {
      if ( !isset($_SESSION['L']['list'][$strField]) ) $_SESSION['L']['list'][$strField] = cVIP::LangGet('list',GetIso(),$strField);
      $arrFields[$strField]['default'] = ObjTrans('list',$strField,false);
      }
      if ( $row['fieldtype']=='D' ) $arrFields[$strField]['default']=date('Ymd Hi');
      if ( $row['fieldtype']=='d' ) $arrFields[$strField]['default']=date('Ymd');
      if ( $row['fieldtype']=='T' ) $arrFields[$strField]['default']=date('Hi');
      if ( $row['fieldtype']=='C' ) $arrFields[$strField]['default']='1';
    }
  }
}

// ---------
// SUBMITTED tab x
// ---------

if ( isset($_POST['ok-other']) )
{
  foreach($arrFields as $strField =>$arrField)
  {      
    if ( isset($_POST[$strField]) ) 
    {
      // format for save (no quote)
      
      $str = trim($_POST[$strField]); if ( $arrField['fieldtype']=='P' && $str=='[...]' ) $str = trim($_POST['other_'.$strField]);
      if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
      $str = QTconv($str,'3');
      
      // check date format (if date not empty)
      
      if ( $str!='' && $arrField['fieldtype']=='T' )
      {
        $str = QTconv($str,'T'); if ( strlen($str)==4 ) $str .= '00';
        if ( !QTisvalidtime($str) ) $error = ObjTrans('field',$strField).' '.Error(1);
      }
      if ( $str!='' && $arrField['fieldtype']=='d' )
      {
        $str = QTdatestr($str,'Ymd','');
        if ( !QTisvaliddate($str) ) $error = ObjTrans('field',$strField).' '.Error(1);
      }
      if ( $str!='' && $arrField['fieldtype']=='D' )
      {
        $str = QTdatestr($str,'Ymd','');
        if ( isset($_POST[$strField.'_time']) ) { if ( !empty($_POST[$strField.'_time']) ) $str .= ' '.QTconv($_POST[$strField.'_time'],'T'); }
        if ( !QTisvaliddate(substr($str,0,8)) ) $error = ObjTrans('field',$strField).' '.Error(1);
      }
      if ( $str!='' && $arrField['fieldtype']=='N' ) { if ( !is_numeric($str) ) $error = ObjTrans('field',$strField).' '.Error(1); }
      
      // save
      
      if ( empty($error) )
      {
      $oTopic->SaveData($t,$tt,$strField,$str);
      $strInfo = $L['S_save'];
      }
    }
  }  
}

// ---------
// FORM
// ---------

// Read the datas

$arrDatas = array();
foreach($arrOtherTabs as $strOtherTab=>$arrOtherTab)
{
  $oDB->Query( 'SELECT fieldid,fieldvalue FROM '.TABDATA.' WHERE tabid="'.$strOtherTab.'" AND id='.$t );
  while($row=$oDB->Getrow())
  {
  $arrDatas[$row['fieldid']] = $row['fieldvalue'];
  }
}

// Display

// animation of the infomessage (errors remains on screen)
if ( isset($strInfo) ) 
{
echo '
<p id="infomessage" style="color:#007F11"><b>',$strInfo,'</b></p>
<script type="text/javascript">
<!--
setTimeout(\'document.getElementById("infomessage").style.color="#bbbbbb"\',3000);
setTimeout(\'document.getElementById("infomessage").style.color="#cccccc"\',3300);
setTimeout(\'document.getElementById("infomessage").style.color="#dddddd"\',3600);
setTimeout(\'document.getElementById("infomessage").innerHTML="&nbsp;"\',3900);
-->
</script>
';
}

if ( !empty($error) ) echo '<p><span class="error">',$error,'</span></p>';

foreach($arrOtherTabs as $strOtherTab=>$arrOtherTab)
{
  echo '<p><span class="bold">',$arrOtherTab['tabname'],(empty($arrOtherTab['tabdesc']) ? '' : '</span> &middot; '.$arrOtherTab['tabdesc']),'</p>';

  if ( $bCanEdit && $_SESSION[QT]['editing'] ) echo '<form method="post" action="',Href(),'">';

  echo '
  <table cellspacing="0" class="field">
  <colgroup span="3"><col width="150"><col></col><col></col></colgroup>
  ';

  // display fields

  $intCount=0;
  foreach($arrFields as $strField =>$arrField)
  { 
    if ( $arrField['tabid']==$strOtherTab )
    {
    HtmlDataRow(($_SESSION[QT]['editing'] ? 'F' : 'T'),$arrField,( isset($arrDatas[$strField]) ? $arrDatas[$strField] : '' ),$strOtherTab);
    $intCount++;
    }
  }

  if ( $intCount==0 ) HtmlDataRow('0');

  echo '
  </table>
  ';

  // Edit

  if ( $intCount>0 && $bCanEdit && $_SESSION[QT]['editing'] )
  {
  echo '
  <p style="text-align:center">
  <input type="hidden" id="s" name="s" value="',$s,'"/>
  <input type="hidden" id="t" name="t" value="',$t,'"/>
  <input type="hidden" id="tt" name="tt" value="',$strOtherTab,'"/>
  <input type="submit" id="ok-other" name="ok-other" value="',$L['Save'],'"/>
  </p>
  </form>
  ';
  }
}