<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');

// INITIALISE

$oVIP->selfurl = 'qtr_privacy.php';
$oVIP->selfname = $L['Legal'];

// --------
// HTML START
// --------

$oHtml->scripts = array();
include('qtr_p_header.php');

$oHtml->Msgbox($oVIP->selfname,array('style'=>'width:620px'));

include(Translate('sys_rules.txt'));
if ( QTR_USE_COPPA ) include(Translate('sys_rules_coppa.txt'));

$oHtml->Msgbox();

$oHtml->Msgbox('About Q-registrations',array('style'=>'width:620px'));

$strFile = Translate('sys_about.php');
if ( file_exists($strFile) ) { include($strFile); } else { echo 'Missing file:<br />'.$strFile; }

echo '<p>
<a href="http://validator.w3.org/check?uri=referer"><img src="admin/vxhtml10.png" alt="Valid XHTML 1.0 Strict" height="31" width="88" /></a>&nbsp;
<a href="http://jigsaw.w3.org/css-validator/"><img src="admin/vcss.png" alt="Valid CSS" height="31" width="88" /></a>&nbsp;
<a href="http://www.w3.org/WAI/WCAG1AAA-Conformance" title="Explanation of Level Triple-A Conformance"><img height="31" width="88" src="admin/wcag1aaa.png" alt="Level Triple-A conformance icon, W3C-WAI Web Content Accessibility Guidelines 1.0" /></a>
';

// ----------
// module rss
if ( UseModule('rss') )
{
echo '<img height="31" width="88" src="admin/valid-rss-rogers.png" alt="[Valid RSS]" title="Valid RSS feed" /> 
<img height="31" width="88" src="admin/valid-atom.png" alt="[Valid RSS]" title="Valid RSS feed" />
';
}
// ----------

echo '</p>
';

$oHtml->Msgbox();

// HTML END

include('qtr_p_footer.php');