<?php

// Q-registrations 2.5 build:20110627

include('qtr_stats_inc_g.php');

// DISPLAY title & option

echo '<table class="hidden" cellspacing="0">';
echo '<tr class="hidden" style="vertical-align:middle;">';
echo '<td><h2>',$y-1,'-',$y,($s>=0 ? ' '.$oVIP->sections[$s] : ''),($type=='I' ? ' '.$L['Inspections'] : ''),($type=='A' ? ' '.$L['Newss'] : ''),(empty($tag) ? '' : ', '.$L['Withtag'].' '.str_replace(';',' '.$L['or'].' ',$tag)),'</h2></td>',N;
echo '<td class="small" style="text-align:right">',implode(' &middot; ',$arrMenuTime),'</td>';
echo '</tr></table>
';

// DISPLAY VALUES

// -----
foreach($arrYears as $y) {
// -----

// Display table header

echo '<table class="data_t" cellspacing="0">
<tr class="data_t">
<td class="colhd" style="width:85px">',$y,'</td>
<td class="colhd" style="width:14px">&nbsp;</td>
';
switch($ch['time'])
{
case 'q': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="colhd" style="text-align:center;">Q',$i,'</td>'; } break;
case 'm': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="colhd" style="text-align:center;">',$L['dateMM'][$i],'</td>'; } break;
case 'd': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="colhd" style="text-align:center;">',str_replace(' ','<br/>',QTdatestr(DateAdd($strTendaysago,$i,'day'),'d M','')),'</td>'; } break;
}
echo '<td class="colhd" style="text-align:center;"><b>',($ch['time']=='d' ? '10 '.strtolower($L['Days']) : $L['Year']),'</b></td>
</tr>';

// DISPLAY TOPICS [value]

echo '<tr class="data_o">',N;
echo '<td class="colhd">',$L['Topics'],'</td>',N;
echo '<td class="colhd"><div style="margin:0 auto;background-color:'.($y==$intCurrentYear ? '#000066' : '#00AFFF').';width:8px;height:10px">&nbsp;</div></td>',N;
for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
{
  echo '<td class="colct" style="text-align:center;">',(isset($arrT[$y][$intBt]) ? $arrT[$y][$intBt] : '&middot;'),'</td>',N;
}
echo '<td class="colct" style="text-align:center;padding:5px;"><b>',$arrTs[$y],'</b></td></tr>',N;

// DISPLAY MESSAGES [value]

echo '<tr class="data_o">',N;
echo '<td class="colhd">',$L['Replys'],'</td>',N;
echo '<td class="colhd"><div style="margin:0 auto;background-color:'.($y==$intCurrentYear ? '#990099' : '#F1B8FF').';width:8px;height:10px">&nbsp;</div></td>',N;
for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
{
  echo '<td class="colct" style="text-align:center;">',(isset($arrM[$y][$intBt]) ? $arrM[$y][$intBt] : '&middot;'),'</td>',N;
}
echo '<td class="colct" style="text-align:center;padding:5px;"><b>',$arrMs[$y],'</b></td></tr>',N;

// DISPLAY USERS [value]

echo '<tr class="data_o">',N;
echo '<td class="colhd">',$L['Users'],'*</td>',N;
echo '<td class="colhd"><div style="margin:0 auto;background-color:'.($y==$intCurrentYear ? '#009999' : '#00E7B7').';width:8px;height:10px">&nbsp;</div></td>',N;
for ($intBt=1;$intBt<=$intMaxBt;$intBt++) 
{
  echo '<td class="colct" style="text-align:center;">',(isset($arrU[$y][$intBt]) ? $arrU[$y][$intBt] : '&middot;'),'</td>',N;
}
echo '<td class="colct" style="text-align:center;padding:5px;"><b>',$arrUs[$y],'</b></td></tr>',N;
echo '</table>
';

// -----
}
// -----

// -----
// DISPLAY TRENDS [value|percent]
// -----

// Table header

echo '<p class="small" style="text-align:right">',implode(' &middot; ',$arrMenuTrend),'</p>';

echo '<table class="data_t" cellspacing="0">
<tr class="data_t">
<td class="colhd" style="width:85px">',$L['Trends'],'</td>
<td class="colhd" style="width:14px">&nbsp;</td>
';
switch($ch['time'])
{
case 'q': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="colhd" style="text-align:center;">Q',$i,'</td>'; } break;
case 'm': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="colhd" style="text-align:center;">',$L['dateMM'][$i],'</td>'; } break;
case 'd': for ($i=1;$i<=$intMaxBt;$i++) { echo '<td class="colhd" style="text-align:center;">',str_replace(' ','<br/>',QTdatestr(DateAdd($strTendaysago,$i,'day'),'d M','')),'</td>'; } break;
}
echo '<td class="colhd" style="text-align:center;"><b>',($ch['time']=='d' ? '10 '.strtolower($L['Days']) : $L['Year']),'</b></td>
</tr>';

// Topics trends

echo '<tr class="data_o">',N;
echo '<td class="colhd">',$L['Topics'],'</td>',N;
echo '<td class="colhd">&nbsp;</td>',N;

for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
{
  $str = '0';
  $i = QTtrend((isset($arrT[$y][$intBt]) ? $arrT[$y][$intBt] : 0),(isset($arrT[$y-1][$intBt]) ? $arrT[$y-1][$intBt] : 0),$ch['trend']=='p');
  if ( isset($i) )
  {
    if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
    if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  }
  else
  {
    $str = '&middot;';
  }
  echo '<td class="colct" style="text-align:center;">',$str,'</td>',N;  
}

$str = '0';
$i = QTtrend($arrTs[$y],$arrTs[$y-1],$ch['trend']=='p');
if ( isset($i) )
{
  if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
}
else
{
  $str = '&middot;';
}
echo '<td class="colct" style="text-align:center;"><b>',$str,'</b></td></tr>',N;

// Replies trends

echo '<tr class="data_o">',N;
echo '<td class="colhd">',$L['Replys'],'</td>',N;
echo '<td class="colhd">&nbsp;</td>',N;

for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
{
  $str = '0';
  $i = QTtrend((isset($arrM[$y][$intBt]) ? $arrM[$y][$intBt] : 0),(isset($arrM[$y-1][$intBt]) ? $arrM[$y-1][$intBt] : 0),$ch['trend']=='p');
  if ( isset($i) )
  {
    if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
    if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  }
  else
  {
    $str = '&middot;';
  }
  echo '<td class="colct" style="text-align:center;">',$str,'</td>',N;  
}

$str = '0';
$i = QTtrend($arrMs[$y],$arrMs[$y-1],$ch['trend']=='p');
if ( isset($i) )
{
  if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
}
else
{
  $str = '&middot;';
}
echo '<td class="colct" style="text-align:center;"><b>',$str,'</b></td></tr>',N;

// Users trends

echo '<tr class="data_o">',N;
echo '<td class="colhd">',$L['Users'],'*</td>',N;
echo '<td class="colhd">&nbsp;</td>',N;

for ($intBt=1;$intBt<=$intMaxBt;$intBt++)
{
  $str = '0';
  $i = QTtrend((isset($arrU[$y][$intBt]) ? $arrU[$y][$intBt] : 0),(isset($arrU[$y-1][$intBt]) ? $arrU[$y-1][$intBt] : 0),$ch['trend']=='p');
  if ( isset($i) )
  {
    if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
    if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  }
  else
  {
    $str = '&middot;';
  }
  echo '<td class="colct" style="text-align:center;">',$str,'</td>',N;  
}

$str = '0';
$i = QTtrend($arrUs[$y],$arrUs[$y-1],$ch['trend']=='p');
if ( isset($i) )
{
  if ( $i>0 ) $str = '<span style="color:red">'.'+'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
  if ( $i<0 ) $str = '<span style="color:green">'.$i.($ch['trend']=='p' ? '%' : '').'</span>';
}
else
{
  $str = '&middot;';
}
echo '<td class="colct" style="text-align:center;"><b>',$str,'</b></td></tr>',N;

echo '</table>
';

echo '<p>*  <span class="small">',$L['Distinct_users'],'</span></p>
';

// After values display change the null values to zero to be able to make charts

foreach($arrYears as $y)
{
$arrT[$y] = QTarrayzero($arrT[$y]);
$arrM[$y] = QTarrayzero($arrM[$y]);
$arrU[$y] = QTarrayzero($arrU[$y]);
}

// -----
// GRAPH
// -----

if ( file_exists('pChart/pChart.class') && file_exists('pChart/pData.class') && !isset($_GET['oldgraph']) )
{
  // abscise Label
  $arrA = array();
  switch($ch['time'])
  {
  case 'q': for ($i=1;$i<=$intMaxBt;$i++) { $arrA[$i]='Q'.$i; } break;
  case 'm': for ($i=1;$i<=$intMaxBt;$i++) { $arrA[$i]=$L['dateMM'][$i]; } break;
  case 'd': for ($i=1;$i<=$intMaxBt;$i++) { $arrA[$i]=substr(DateAdd($strTendaysago,$i,'day'),-2,2); } break;
  }

  // Standard inclusions and prepare CACHE
  include('pChart/pData.class');
  include('pChart/pChart.class');
  if ( file_exists('pChart/pCache.class') )
  {
  include('pChart/pCache.class');
  $Cache = new pCache('pChart/Cache/'); // variable must be created here (re-used as global in QTpchart function)
  CheckChartCache($Cache);
  }

  // Check cache
  $intHandle = opendir('pChart/Cache');
  $i = 0;
  while ( false!==($strFile = readdir($intHandle)) ) $i++;
  closedir($intHandle);
  // clear cache if to much files
  if ( $i>60 || isset($_GET['clearcache']) ) $Cache->ClearCache();
  
  // -------
  // Graphs
  // -------

  // charttitle,abscise,dataset,datasetname,graphoptions,filename,color,cumul
  $strChart1 = QTpchart(
    $L['Topics_per_'.$ch['time']].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrT[$y-1],'Serie2'=>$arrT[$y] ),
    array( 'Serie1'=>$y-1,'Serie2'=>$y ),
    $ch,
    $tt.'1'.$y.implode('',$ch).GetIso(),
    1);
  $strChart2 = QTpchart(
    $L['Replies_per_'.$ch['time']].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrM[$y-1],'Serie2'=>$arrM[$y] ),
    array( 'Serie1'=>$y-1,'Serie2'=>$y ),
    $ch,
    $tt.'2'.$y.implode('',$ch).GetIso(),
    2);
  $strChart3 = QTpchart(
    $L['Users_per_'.$ch['time']].($ch['value']=='p' ? ' (%)' : ''),
    $arrA,
    array( 'Serie1'=>$arrU[$y-1],'Serie2'=>$arrU[$y] ),
    array( 'Serie1'=>$y-1,'Serie2'=>$y ),
    $ch,
    $tt.'3'.$y.implode('',$ch).GetIso(),
    3);

  // -------
  // DISPLAY
  // -------

  echo '<div style="margin:0 auto; width:600px">',N;
  echo '<p class="small" style="text-align:right">',implode(' &middot; ',$arrMenuType),'</p>';
  echo '<img id="chart1" src="'.$strChart1.'"/><br/>';
  echo '<img id="chart2" src="'.$strChart2.'"/><br/>';
  echo '<img id="chart3" src="'.$strChart3.'"/><br/>';
  echo '</div>',N;

}
elseif ( file_exists('bin/qt_lib_graph.php') && file_exists($_SESSION[QT]['skin_dir'].'/qtr_main2.css') )
{

  echo '<p class="small" style="text-align:right">',implode(' &middot; ',$arrMenuValue),'</p>';

  // TOPIC first serie
  
  $intTopY = QTroof( array(max($arrT[$y-1]),max($arrT[$y])) );
  
  echo '<table class="data_t" cellspacing="0">',N;
  echo '<tr class="data_t">',N;
  echo '<td class="colct" style="width:355px">',N;
  
  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrT[$y-1])),350,100,$intTopY,2,'P',$L['Topics_per_'.$ch['time']].' (%)'.' '.$y);
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrT[$y-1]),320,100,$intTopY,2,true,$L['Topics_per_'.$ch['time']].' '.$y);
  }

  echo '</td>',N;  
  echo '<td class="colct">&nbsp;</td>',N;
  echo '<td class="colct" style="width:355px">',N;

  // TOPIC second serie

  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrT[$y])),350,100,$intTopY,2,'P',$L['Topics_per_'.$ch['time']].' (%)'.' '.$y);
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrT[$y]),320,100,$intTopY,2,true,$L['Topics_per_'.$ch['time']].' '.$y);
  }

  echo '</td>',N;
  echo '</tr>',N;

  // MESSAGE first serie
  
  $intTopY = QTroof( array(max($arrM[$y-1]),max($arrM[$y])) );
  
  echo '<tr class="data_o">',N;
  echo '<td class="colct" style="width:355px">',N;
  
  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrM[$y-1])),350,100,$intTopY,2,'P',$L['Replies_per_'.$ch['time']].' (%)'.' '.$y,'','2');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrM[$y-1]),320,100,$intTopY,2,true,$L['Replies_per_'.$ch['time']].' '.$y,'','2');
  }

  echo '</td>',N;  
  echo '<td class="colct">&nbsp;</td>',N;
  echo '<td class="colct" style="width:355px">',N;

  // MESSAGE second serie

  if ( $ch['value']=='p' ) 
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrM[$y])),350,100,$intTopY,2,'P',$L['Replies_per_'.$ch['time']].' (%)'.' '.$y,'','2');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,$arrM[$y]),320,100,$intTopY,2,true,$L['Replies_per_'.$ch['time']].' '.$y,'','2');
  }

  echo '</td>',N;
  echo '</tr>',N;

  // USER first serie
  
  $intTopY = QTroof( array(max($arrU[$y-1]),max($arrU[$y])) );
  
  echo '<tr class="data_o">',N;
  echo '<td class="colct" style="width:355px">',N;
  
  if ( $ch['value']=='a' ) 
  {
  QTbarchart(QTarraymerge($arrA,$arrU[$y-1]),320,100,$intTopY,2,true,$L['Users_per_'.$ch['time']].' '.$y,'','3');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrU[$y-1])),350,100,$intTopY,2,'P',$L['Users_per_'.$ch['time']].' (%)'.' '.$y,'','3');
  }

  echo '</td>',N;  
  echo '<td class="colct">&nbsp;</td>',N;
  echo '<td class="colct" style="width:355px">',N;

  // USER second serie

  if ( $ch['value']=='a' ) 
  {
  QTbarchart(QTarraymerge($arrA,$arrU[$y]),320,100,$intTopY,2,true,$L['Users_per_'.$ch['time']].' '.$y,'','3');
  }
  else
  {
  QTbarchart(QTarraymerge($arrA,QTpercent($arrU[$y])),350,100,$intTopY,2,'P',$L['Users_per_'.$ch['time']].' (%)'.' '.$y,'','3');
  }

  echo '</td>',N;
  echo '</tr></table>',N;

}
else
{
  echo '<p class="small">Graphs cannot be displayed because one of these files is missing: bin/qt_lib_graph.php, ',$_SESSION[QT]['skin_dir'].'/qtr_main2.css</p>';
}

?>