<?php

// Q-registrations 2.5 build:20110627

// ---------
// INITIALIZE get field definition of this tab
// ---------

CheckDico('field fielddesc');

$arrFields = array();
$oDB->Query( 'SELECT * FROM '.TABFIELD.' WHERE tabid="'.$tt.'"'.($oVIP->role=='U'||$oVIP->role=='V' ? ' AND fieldselect="1"' : '').' ORDER by fieldorder' );
while($row=$oDB->Getrow()) { if ( !empty($row['fieldid']) ) $arrFields[$row['fieldid']] = $row; }   

// add the default value (of this langue) if required (date unformated)
foreach($arrFields as $strField=>$row)
{
  $arrFields[$strField]['default'] = '';
  if ( $row['fielddefault']=='1' ) {
  switch($row['fieldtype']) {
    case 'S':
    case 'L':
    case 'P':
    case 'N':
      if ( !isset($_SESSION['L']['list'][$strField]) ) $_SESSION['L']['list'][$strField] = cVIP::LangGet('list',GetIso(),$strField);
      $arrFields[$strField]['default'] = ObjTrans('list',$strField,false);
      break;
    case 'D': $arrFields[$strField]['default']=date('Ymd Hi'); break;
    case 'd': $arrFields[$strField]['default']=date('Ymd'); break;
    case 'T': $arrFields[$strField]['default']=date('Hi'); break;
    case 'C': $arrFields[$strField]['default']='1'; break;
  }}
}

// ---------
// SUBMITTED tab x
// ---------

if ( isset($_POST['ok-'.$tt]) )
{
  foreach($arrFields as $strField =>$arrField)
  {      
    if ( isset($_POST[$strField]) ) 
    {
      // format for save (no quote)
      
      $str = trim($_POST[$strField]); if ( $arrField['fieldtype']=='P' && $str=='[...]' ) $str = trim($_POST['other_'.$strField]);
      if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
      $str = QTconv($str,'3');
      
      // check date format (if date not empty)
      
      if ( $str!='' && $arrField['fieldtype']=='T' )
      {
        $str = QTconv($str,'T'); if ( strlen($str)==4 ) $str .= '00';
        if ( !QTisvalidtime($str) ) $error = ObjTrans('field',$strField).' '.Error(1);
      }
      if ( $str!='' && $arrField['fieldtype']=='d' )
      {
        $str = QTdatestr($str,'Ymd','');
        if ( !QTisvaliddate($str) ) $error = ObjTrans('field',$strField).' '.Error(1);
      }
      if ( $str!='' && $arrField['fieldtype']=='D' )
      {
        $str = QTdatestr($str,'Ymd','');
        if ( isset($_POST[$strField.'_time']) ) { if ( !empty($_POST[$strField.'_time']) ) $str .= ' '.QTconv($_POST[$strField.'_time'],'T'); }
        if ( !QTisvaliddate(substr($str,0,8)) ) $error = ObjTrans('field',$strField).' '.Error(1);
      }
      if ( $str!='' && $arrField['fieldtype']=='N' ) { if ( !is_numeric($str) ) $error = ObjTrans('field',$strField).' '.Error(1); }
      
      // save
      
      if ( empty($error) )
      {
      $oTopic->SaveData($t,$tt,$strField,$str);
      $strInfo = $L['S_save'];
      }
    }
  }  
}

// ---------
// FORM
// ---------

// Read the datas

$arrDatas = array();
  $oDB->Query( 'SELECT fieldid,fieldvalue FROM '.TABDATA.' WHERE tabid="'.$tt.'" AND id='.$t );
  while($row=$oDB->Getrow()) $arrDatas[$row['fieldid']] = $row['fieldvalue'];

// Display

// animation of the infomessage (errors remains on screen)
if ( isset($strInfo) || !empty($error) )
{
  echo '
  <p>';
  if ( !empty($error) ) echo ' <span class="error">',$error,'</span> ';
  if ( isset($strInfo) ) 
  {
  echo '
  <span class="bold" id="infomessage" style="color:#007F11">',$strInfo,'</span>
  <script type="text/javascript">
  <!--
  setTimeout(\'document.getElementById("infomessage").style.color="#bbbbbb"\',3000);
  setTimeout(\'document.getElementById("infomessage").style.color="#cccccc"\',3300);
  setTimeout(\'document.getElementById("infomessage").style.color="#dddddd"\',3600);
  setTimeout(\'document.getElementById("infomessage").innerHTML="&nbsp;"\',3900);
  -->
  </script>
  ';
  }
  echo '</p>'.PHP_EOL;
}

if ( $bCanEdit && $_SESSION[QT]['editing'] ) echo '<form method="post" action="',Href(),'">';

echo '
<table cellspacing="0" class="field">
<colgroup span="3"><col width="150"></col><col></col><col></col></colgroup>
';

// display fields

$intCount=0;
foreach($arrFields as $strField =>$arrField)
{
  // format to display field
  $strFormat = ( $_SESSION[QT]['editing'] ? 'F' : 'T');
  if ( $arrField['fieldupdate']=='0' ) { if ( $oVIP->role=='U' || $oVIP->role=='V' ) $strFormat = 'T'; }
  // display field
  HtmlDataRow($strFormat,$arrField,( isset($arrDatas[$strField]) ? $arrDatas[$strField] : '' ),$tt);
  $intCount++;
}
if ( $intCount==0 ) HtmlDataRow('0');

echo '
</table>
';

// Edit

if ( $intCount>0 && $bCanEdit && $_SESSION[QT]['editing'] )
{
echo '
<p style="text-align:center">
<input type="hidden" id="t" name="t" value="',$t,'"/>
<input type="hidden" id="tt" name="tt" value="',$tt,'"/>
<input type="submit" id="ok-',$tt,'" name="ok-',$tt,'" value="',$L['Save'],'"/>
</p>
</form>
';
}